
#include <allegro.h>
#include <stdio.h>
#include <stdlib.h>

fixed fixmul2(fixed a0, fixed b0) {
  long long a = a0;
  long long b = b0;
  return (a*b)>>16;
}

fixed rand_fixed() {
  int ans = rand()^(rand()<<8);
  if (rand()%2==0) { ans = -ans; }
  return ans;
}

void test_pair() {
  fixed a = rand_fixed();
  fixed b = rand_fixed();
  fixed c = fixmul(a, b);
  fixed d = fixmul2(a, b);
  if (c != d) { fprintf(stderr, "Error: %d %d %d %d\n", a, b, c, d); exit(1); }
}

int main() {
  allegro_init();
  for (int i = 0;; i++) {
    printf("%d\n", i);
    test_pair();
  }
  return 0;
}

END_OF_MAIN();
