
#ifndef _allegro_emu_h
#define _allegro_emu_h

typedef struct BITMAP {
  int w, h;
  unsigned char **line;
  unsigned char *data;
} BITMAP;

int _getpixel32(BITMAP *a, int x, int y);
void _putpixel32(BITMAP *a, int x, int y, int c);
int getr32(int c);
int getg32(int c);
int getb32(int c);
BITMAP *create_bitmap(int w, int h);
void blit(BITMAP *a, BITMAP *b, int ax, int ay, int bx, int by, int w, int h);
void destroy_bitmap(BITMAP *bmp);
typedef int fixed;
fixed fixmul(fixed a, fixed b);
void clear(BITMAP *bmp);
void clear_to_color(BITMAP *bmp, int c);
/*
unsigned makecol(int r, int g, int b);
int bitmap_mask_color(BITMAP *bmp);
*/

#endif
